#ifndef _fencer_program_h
#define _fencer_program_h

#include <SDL2/SDL.h>
#include <SDL2/SDL_render.h>
#include "vmath.h"
#include "render.h"

extern struct Program g_program;

struct ProgramSettings {
    const char* title;
    IVector view_resolution;
    int target_fps;
};

struct Program {
    SDL_Window* window;
    struct RenderContext* render_context;
    double delta_time;
    double start_frame;
};

extern int program_run(const struct ProgramSettings* settings);
extern void program_quit(struct Program* self);
extern void program_handle_events(struct Program* self);
extern void program_handle_windowevent(struct Program* self, SDL_WindowEvent* event);

#endif // !_fencer_program_h
