#ifndef _fencer_tilemap_h
#define _fencer_tilemap_h

#include "vmath.h"
#include "render.h"
#include <SDL2/SDL.h>

struct Tileset {
	SDL_Texture* texture;
	IVector tile_size;
	IVector texture_resolution;
	int shear;
};

struct Tilemap {
	IVector dimensions;
	int* tiles;
	struct Tileset tileset;
};

extern struct Tilemap tilemap_load(const char* tilemap_file, const char* tileset_file);
extern struct Tileset tileset_load(const char* filename);
extern SDL_Rect tileset_index_to_rect(struct Tileset* self, size_t index);

extern void tilemap_render(struct Tilemap* map, struct RenderContext* render);

#endif // !_fencer_tilemap_h
